// AniCursorDemo.java

// Test an animated cursor.

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

import ca.mb.javajeff.anicursor.*;

public class AniCursorDemo extends JFrame
{
   AniCursor anicursor;

   JButton btnStop;

   JLabel label;

   public AniCursorDemo (final String aniName)
   {
      super ("AniCursorDemo");
      setDefaultCloseOperation (EXIT_ON_CLOSE);

      GPanel gpanel = new GPanel ();

      final JButton btnStart = new JButton ("Start");
      ActionListener al;
      al = new ActionListener ()
           {
               public void actionPerformed (ActionEvent ae)
               {
                  if (anicursor == null)
                      try
                      {
                          anicursor = new AniCursor (aniName, label);
                      }
                      catch (Exception ex)
                      {
                          System.err.println (ex.getMessage ());
                          return;
                      }

                  btnStop.setEnabled (true);
                  btnStart.setEnabled (false);
                  anicursor.start ();
               }
           };
      btnStart.addActionListener (al);
      gpanel.add (btnStart);

      gpanel.add (label = new JLabel ("Animated cursor only appears over this "+
                                      "label!"));
      label.setBorder (BorderFactory.
                       createCompoundBorder (BorderFactory.
                                             createEtchedBorder (),
                                             BorderFactory.
                                             createEmptyBorder (5, 5, 5, 5)));

      btnStop = new JButton ("Stop");
      btnStop.setEnabled (false);
      al = new ActionListener ()
           {
               public void actionPerformed (ActionEvent ae)
               {
                  anicursor.stop ();
                  btnStart.setEnabled (true);
                  btnStop.setEnabled (false);
               }
           };
      btnStop.addActionListener (al);
      gpanel.add (btnStop);

      setContentPane (gpanel);

      pack ();
      setResizable (false);
      setVisible (true);
   }

   public static void main (final String [] args)
   {
      Runnable r;
      r = new Runnable ()
          {
              public void run ()
              {
                 new AniCursorDemo (args.length == 0 ? null : args [0]);
              }
          };
      EventQueue.invokeLater (r);
   }
}

class GPanel extends JPanel
{
   private GradientPaint gp;

   public void paintComponent (Graphics g)
   {
      Graphics2D g2d = (Graphics2D) g;

      if (gp == null)
          gp = new GradientPaint (0, 0, Color.white, 0,
                                  getHeight (), Color.pink);

      // Paint a nice gradient background with white at the top and pink at
      // the bottom.

      g2d.setPaint (gp);
      g.fillRect (0, 0, getWidth (), getHeight ());
   }
}
